# Flame Behaviors

[![ci][ci_badge]][ci_link]
[![coverage][coverage_badge]][ci_link]
[![pub package][pub_badge]][pub_link]
[![style: very good analysis][very_good_analysis_badge]][very_good_analysis_link]
[![License: MIT][license_badge]][license_link]
[![Powered by Flame][flame_badge_link]]([flame_link])

Flame Behaviors applies separation of concerns to game logic in the form of Entities and Behaviors.

Developed with 💙 and 🔥 by [Very Good Ventures][very_good_ventures_link] 🦄

---

## Quick Start 🚀

### Installing 🧑‍💻

In order to use Flame Behaviors you must have the [Flame package][flame_package_link] added to your 
project.

> **Note**: Flame Behaviors requires Flame `">=1.10.0 <2.0.0"`

### Adding the package

```shell
# 📦 Install the flame_behaviors package from pub.dev
flutter pub add flame_behaviors
```

## Creating Entities and Behaviors

Use Flame Behaviors to define your entities in your game and their behavioral aspects. Or follow 
the [Introduction to Flame Behaviors][flame_behaviors_article] article to get you familiar with 
the concepts!

## Documentation 📝

View the full documentation [here][flame_behaviors_documentation].

[ci_badge]: https://github.com/VeryGoodOpenSource/flame_behaviors/workflows/flame_behaviors/badge.svg
[ci_link]: https://github.com/VeryGoodOpenSource/flame_behaviors/actions
[coverage_badge]: https://raw.githubusercontent.com/VeryGoodOpenSource/flame_behaviors/main/coverage_badge.svg
[license_badge]: https://img.shields.io/badge/license-MIT-blue.svg
[license_link]: https://opensource.org/licenses/MIT
[pub_badge]: https://img.shields.io/pub/v/flame_behaviors.svg
[pub_link]: https://pub.dartlang.org/packages/flame_behaviors
[very_good_analysis_badge]: https://img.shields.io/badge/style-very_good_analysis-B22C89.svg
[very_good_analysis_link]: https://pub.dev/packages/very_good_analysis
[very_good_ventures_link]: https://verygood.ventures/?utm_source=github&utm_medium=banner&utm_campaign=CLI
[flame_badge_link]: https://img.shields.io/badge/Powered%20by-%F0%9F%94%A5-orange.svg
[flame_link]: https://flame-engine.org
[flame_package_link]: https://pub.dev/packages/flame
[flame_behaviors_article]: https://verygood.ventures/blog/build-games-with-flame-behaviors
[flame_behaviors_documentation]: https://github.com/VeryGoodOpenSource/flame_behaviors/tree/main/docs